// maincr2.cpp

#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;
int main()
{
    cout << "\n *** START CR2: Credit Default Swaps *** \n";

    // STEP 1: INPUT PARAMETERS
   	double T=1; // maturity
   	int N=4; // number of payments per year
   	double dt = T / N;
   	double notional = 100; // notional
   	double t = 0.0; // current time
   	double r=0.05; // risk free interest rate
   	double h=0.01; // hazard rate
    double rr=0.50; // recovery rate
    double pv_premium_leg=0.0; // sum premium leg
    double pv_default_leg=0.0; // sum default leg
    double cds_spread=0;
    double DF[20];
    double P[20];
    P[0]=1.0;

    // STEP 2: LOOP FOR ALL PAYMENTS
    for (int j=1; j < N*T+1 ; j++)
   	{
       t = j*dt;
       DF[j]=exp(-r*t);
       P[j]=exp(-h*t);
       // STEP 3: COMPUTE PREMIUM PAYMENTS
       pv_premium_leg = pv_premium_leg + DF[j]*notional*dt*P[j];
       // STEP 4: COMPUTE DEFAULT PAYMENTS
       pv_default_leg = pv_default_leg + DF[j]*(1-rr)*notional*(P[j-1]-P[j]);
    }

    // STEP 5: COMPUTE CDS SPREAD
    cds_spread = pv_default_leg / pv_premium_leg;

    // STEP 6: OUTPUT RESULTS
    cout <<"PV premium leg =  " << pv_premium_leg  << "\n";
    cout <<"PV default leg =  " << pv_default_leg << " \n";
    cout <<" cds_spread =  " << cds_spread*10000 << "  bps \n";
    cout << "\n *** END CR2: Credit Default Swaps *** \n";

	return 0;
}
